

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>d2o.analyze.fourier &mdash; d2o Python Library 1.0 documentation</title>
  

  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  

  

  
    <link rel="top" title="d2o Python Library 1.0 documentation" href="../../../index.html"/>
        <link rel="up" title="Module code" href="../../index.html"/> 

  
  <script src="../../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../../index.html" class="icon icon-home"> d2o Python Library
          

          
          </a>

          
            
            
              <div class="version">
                1.0
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <ul class="simple">
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../../../index.html">d2o Python Library</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          





<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../../../index.html">Docs</a> &raquo;</li>
      
          <li><a href="../../index.html">Module code</a> &raquo;</li>
      
    <li>d2o.analyze.fourier</li>
      <li class="wy-breadcrumbs-aside">
        
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for d2o.analyze.fourier</h1><div class="highlight"><pre>
<span></span><span class="c1"># -*- encoding: utf-8 -*-</span>
<span class="c1">#</span>
<span class="c1"># Copyright (c) 2016 Chronos AS</span>
<span class="c1">#</span>
<span class="c1"># Authors: Fredrik Stormo, Stefan Remman</span>
<span class="c1"># Contact: kjetil.karlsen@chronosit.no</span>

<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="kn">as</span> <span class="nn">pd</span>

<div class="viewcode-block" id="fftdf"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.fourier.fftdf">[docs]</a><span class="k">def</span> <span class="nf">fftdf</span><span class="p">(</span><span class="n">dataFrame</span><span class="p">,</span> <span class="n">keys</span><span class="o">=</span><span class="s2">&quot;ALL&quot;</span><span class="p">):</span>
  <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">  Does a fast fourier transform on the columns in a dataframe. All columns</span>
<span class="sd">  need to contain floats except index column.</span>

<span class="sd">  Parameters</span>
<span class="sd">  ----------</span>
<span class="sd">  dataFrame : pd.DataFrame</span>

<span class="sd">  keys : string or list, default &quot;ALL&quot;.</span>
<span class="sd">    What keys to itterate over in DataFrame.</span>

<span class="sd">  Returns</span>
<span class="sd">  -------</span>
<span class="sd">  fftDF : pd.DataFrame</span>
<span class="sd">    Data Frame containing the absolute value of the fourier transformation of</span>
<span class="sd">    the columns in dataFrame.</span>
<span class="sd">  &quot;&quot;&quot;</span>
  <span class="n">fftDF</span> <span class="o">=</span> <span class="p">{}</span>
  <span class="n">length</span> <span class="o">=</span> <span class="n">dataFrame</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
  <span class="k">if</span> <span class="n">keys</span> <span class="o">==</span> <span class="s2">&quot;ALL&quot;</span><span class="p">:</span>
    <span class="n">keys</span> <span class="o">=</span> <span class="n">dataFrame</span><span class="o">.</span><span class="n">columns</span><span class="o">.</span><span class="n">values</span><span class="o">.</span><span class="n">tolist</span><span class="p">()</span>
  <span class="k">elif</span> <span class="nb">type</span><span class="p">(</span><span class="n">keys</span><span class="p">)</span> <span class="o">==</span> <span class="nb">str</span><span class="p">:</span>
    <span class="n">keys</span> <span class="o">=</span> <span class="p">[</span><span class="n">keys</span><span class="p">]</span>
  <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">keys</span><span class="p">:</span>
    <span class="n">transformed</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">fft</span><span class="o">.</span><span class="n">fft</span><span class="p">(</span><span class="n">dataFrame</span><span class="p">[</span><span class="n">key</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="p">)[</span><span class="mi">0</span><span class="p">:</span><span class="n">length</span><span class="o">/</span><span class="mi">2</span><span class="p">]</span>
    <span class="n">fftDF</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="n">transformed</span><span class="p">)</span>

  <span class="k">return</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="o">.</span><span class="n">from_dict</span><span class="p">(</span><span class="n">fftDF</span><span class="p">)</span></div>


<span class="c1">#import of putils need to be worked out diffrently in the test block. does not work now.</span>
<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s2">&quot;__main__&quot;</span><span class="p">:</span>
  <span class="kn">import</span> <span class="nn">matplotlib.pyplot</span> <span class="kn">as</span> <span class="nn">plt</span>

  <span class="c1">#import sys</span>
  <span class="c1">#sys.path.append(&quot;~/Documents/chronos/clib/utils&quot;)</span>
  <span class="c1">#import putils</span>
  <span class="c1">#import imp</span>
  <span class="c1">#imp.load_source(&quot;putils&quot;, &quot;~/Documents/chronos/clib/utils/putils&quot;)</span>
  <span class="c1">#import d2o.utils.putils as putils</span>

  <span class="n">hotel</span> <span class="o">=</span> <span class="s2">&quot;HotelBristol&quot;</span>
  <span class="n">path</span> <span class="o">=</span> <span class="s2">&quot;~/Documents/chronos/d2o-datasett/&quot;</span> <span class="o">+</span> <span class="n">hotel</span> <span class="o">+</span> <span class="s2">&quot;.csv&quot;</span>

  <span class="c1">#testFrame = pd.read_csv(&quot;~/Documents/chronos/d2o-datasett/BritanniaHotel.csv&quot;, sep=&quot;;&quot;)</span>
  <span class="n">testFrame</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">read_csv</span><span class="p">(</span><span class="n">path</span><span class="p">,</span> <span class="n">sep</span><span class="o">=</span><span class="s2">&quot;;&quot;</span><span class="p">,</span> <span class="n">index_col</span><span class="o">=</span><span class="s2">&quot;Date&quot;</span><span class="p">)</span>

<span class="c1">#  print testFrame.columns.values.tolist()</span>

<span class="c1">#  testFrameMav = putils.add_mav(testFrame, 10)</span>
  <span class="n">testFrameMav</span> <span class="o">=</span> <span class="n">testFrame</span>

<span class="c1">#  figure = plt.figure()</span>
<span class="c1">#  ax = figure.add_subplot(1, 1 ,1)</span>
<span class="c1">##  ax.plot(testFrameMav[&quot;Total_RV_MAV(10)&quot;][365:400].values)</span>
<span class="c1">#  ax.plot(testFrameMav[&quot;Total_RV&quot;][365:400].values)</span>
<span class="c1">#  figure.show()</span>
<span class="c1">#</span>
<span class="c1">#  raw_input(&quot;enter: &quot;)</span>
<span class="c1">#</span>

  <span class="n">length</span> <span class="o">=</span> <span class="n">testFrameMav</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
  <span class="n">index</span> <span class="o">=</span> <span class="n">length</span> <span class="o">-</span> <span class="mi">365</span><span class="o">*</span><span class="mi">2</span>
<span class="c1">#  print length, index</span>
  <span class="n">testFrameMav</span> <span class="o">=</span> <span class="n">testFrameMav</span><span class="o">.</span><span class="n">ix</span><span class="p">[</span><span class="n">index</span><span class="p">:]</span>
<span class="c1">#  print testFrameMav</span>
  <span class="n">otherFrame</span> <span class="o">=</span> <span class="n">fftdf</span><span class="p">(</span><span class="n">testFrameMav</span><span class="p">,</span> <span class="n">keys</span><span class="o">=</span><span class="p">[</span><span class="s2">&quot;Total_RV&quot;</span><span class="p">,</span> <span class="s2">&quot;Total_RN&quot;</span><span class="p">])</span>
  <span class="k">print</span> <span class="n">otherFrame</span>

  <span class="n">fig</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">()</span>
  <span class="n">fig</span><span class="o">.</span><span class="n">suptitle</span><span class="p">(</span><span class="n">hotel</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">20</span><span class="p">)</span>
  <span class="n">ax</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span>
  <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">otherFrame</span><span class="p">[</span><span class="s2">&quot;Total_RV&quot;</span><span class="p">][:</span><span class="o">-</span><span class="n">otherFrame</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">/</span><span class="mi">2</span><span class="p">],</span> <span class="n">label</span><span class="o">=</span><span class="s2">&quot;Total_RV&quot;</span><span class="p">)</span>
<span class="c1">#  ax.plot(otherFrame[&quot;Total_RV_MAV(10)&quot;][:-otherFrame.shape[0]/2], label=&quot;MAV&quot;)</span>
  <span class="n">ax</span><span class="o">.</span><span class="n">grid</span><span class="p">(</span><span class="n">b</span><span class="o">=</span><span class="bp">True</span><span class="p">)</span>
  <span class="n">ax</span><span class="o">.</span><span class="n">legend</span><span class="p">()</span>

  <span class="n">fig</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>

  <span class="c1">#testFrame.plot()</span>

  <span class="nb">raw_input</span><span class="p">(</span><span class="s2">&quot;something&quot;</span><span class="p">)</span>
</pre></div>

           </div>
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2016, Chronos AS.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../../',
            VERSION:'1.0',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../../_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

  

  
  
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>